<?php
/**
 * @fileID: $Id: download.php 8331 2012-05-28 07:07:44Z alfiya $
 * @changedDate: $LastChangedDate: 2012-05-28 14:07:44 +0700 (Mon, 28 May 2012) $
 * @changedBy: $LastChangedBy: alfiya $
 * MightyResources Product type plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeDownload extends JPlugin
{
	function plgJoomsuite_product_typeDownload( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';

		$this->helper = & JS_Res_FancyUploaderHelper::getInstance();

		$path = JPATH_PLUGINS.DS.'joomsuite_product_type'.DS.'html'.DS.'jspt_res_file_manager.php';
		if (JFile::exists($path))
		require_once $path;
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'download') return;
		$index = 'file-'.$obj->id;
		$sess = &JFactory::getSession();

		$optExts = $params->get('allowed_formats');
		$out = '';
		if($params->get('unique'))
		{
			if($params->get('unique') == 1)
			{
				$checked = (isset($obj->field_value_id) && $obj->field_value_id)  ? 'checked' : '';
				$out .= '<input type="checkbox" name="file_unique['.$obj->id.']" value="1" '.$checked.'> '.JText::_('Unique download').'<br><br>';
			}
			else
			{
				$out .= '<input type="hidden" name="file_unique['.$obj->id.']" value="1"> '.JText::_('This is a unique download file').'<br><br>';
			}
		}

		if(isset($obj->$index)  && $obj->$index != '' )
		{
			$files = $obj->$index;
			settype($files, 'array');
		}
		else
		$files = array();
		$db = & JFactory::getDBO();
		$sql = 'SELECT user_id FROM #__js_res_record WHERE id = '.$obj->record_id;
		$db->setQuery($sql);
		$obj->user_id = $db->loadResult();

		$recordId 	= JHTMLJsmedia_new::getRealRecordId($obj, $type);
		$url 		= JHTMLJsmedia_new::getUploadUrl($obj, $type, $recordId);
		$debug 		= false;
		$uid 		= uniqid('media_');
		$out .= JText::_('Allowed formats are ').": $optExts<br>";
		switch($params->get('type'))
		{
			case 1:
				$options = array(
				'files' => $files,
			 	'title' => 'Upload your file',
				'url' => $url,			 
				'limitSize' => $params->get('max') ? ((int)$params->get('max')) * 1024 : 'false',
				'maxFiles' => 1,
				'debug' => $debug, // optional
				'backgroundColor' => '#FFFFFF',
				'filters' => explode(", ", $optExts),
				'uid' => $uid,
				'fieldId' => $obj->id,
				'recordId' => $recordId,
				'processResponse' => false,
				'limitFiles' => 1// the number of files in uploader
				);
					
				$out.=  JHTMLJsmedia_new::getUploaderWithFilesTable($obj, $options);
				//$out .= "<input style=\"width:".$params->get('field_size')."\" type=\"file\" name=\"files[{$obj->id}]\" />";
				break;

			case 2:
				$out .= '<input type="text" style="width:'.$params->get('field_size').'" name="pparams['.$obj->id.'][file-'.$obj->id.']" value="'.(isset($obj->$index) ? $obj->$index : '').'" />';
				$out .= '<br>'.JText::_('Insert path based on joomla root.');
				break;
			case 3:
				$filter =  explode(", ", $optExts);
				$out .= '<select style="width:'.$params->get('field_size').'" name="pparams['.$obj->id.'][file-'.$obj->id.']" class="inputbox" size="1">';
				$out .= implode("\n", ResViewRecord::files($params->get('directory')/*.DS.'product_type'.DS.$obj->user_id*/, $params, (isset($obj->$index) ? $obj->$index : ''), $filter));
				$out .= '</select>';
				break;
		}
		if(isset($obj->$index) && $obj->$index && ($params->get('type') == 1) ){
			/*$out .= '<br><input type="checkbox" value="1" name="remove['.$obj->id.']" value="'.$obj->$index.'" />'.JText::_('Remove Current');
			 $out .= " ({$obj->$index})";*/
			$out .= "<input type=\"hidden\" name=\"pparams[".$obj->id."][file-{$obj->id}]\" value=\"{$obj->$index}\" />";
		}

		$out .= '<input type="hidden" name="fields[author]['.$obj->id.']" value="'.$obj->user_id.'">';
		$out .= '<input type="hidden" name="fields['.$obj->id.'][downloadable]" value="1">';
		
		echo $out;
	}

	function onBeforeSave(&$value, &$params, $type, $field_id, $row, &$error)
	{
		if($type != 'download') return;
		$sess = &JFactory::getSession();

		$db     = &JFactory::getDBO();

		$exts = explode(", ", $params->get('allowed_formats'));
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$user = JFactory::getUser();

		$fileManager = & JSPT_Res_File_Manager::getInstance();

		$fields = JRequest::getVar('fields');

		$files = $fields[$field_id]['files'];

		// Check, if the article was newly created
		$shamaned_prefix = JFile::makeSafe($sess->get('new_article_prefix', $row->id, $type));
		$newlyCreated = ($shamaned_prefix != $row->id);

		$shamaned_prefix .= '_';

		$path = JPATH_ROOT.DS.$params->get('directory').DS.'product_type';

		// track author change
		$auth = $_POST['fields']['author'][$field_id];
		$suffix = '';
		if($params->get('attach')) $suffix = '_'.time();

		$author = isset($auth) ? $auth : 0;
		if ($author != $row->user_id)
		$fileManager->reassignFiles($files, $row->id, $author, $row->user_id, $path, $suffix);
			
		//--------------------------------------------------------------------------

		$f = $files[0];
		$f = basename( $f );
		$ext = JString::strtolower(JFile::getExt( $f ));
		if ($ext == 'jpeg')
		$ext = 'jpg';

		if (!in_array($ext, $exts)) {
			$error = true;
			JError::raiseWarning(JText::_('Extension is not allowed').' : '.$ext);
			return;
		}

		if($params->get('type') == 1)
		{
			$ptypes = JRequest::getVar('pparams');
			$old = $ptypes[$field_id]['file-'.$field_id];
			if($old && (!count($files) || $files[0] != $old) )
			{
				$file = JPATH_ROOT.DS.$params->get('directory').DS.'product_type'.DS.$row->user_id.DS.$old;
				if(file_exists($file))
				JFile::delete($file);
			}
		}
		
		$f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

		$res = $fileManager->storeFile($shamaned_prefix.$f, $f, $row->user_id, $path.DS.$row->user_id, true, $suffix);
	
		/*if($res)
		{
				
		}*/

		$sess->clear('new_article_prefix', $type);
		return $res;
	}


	/*	function onBeforeSave2(&$value, &$params, $type, $id, $row, &$error)
	 {
		if($type != 'download') return;
		if(!$value) return;
		$db = &JFactory::getDBO();
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		$path = JPATH_ROOT.DS.$params->get('directory');

		$fields = JRequest::getVar('fields');
		$download_id = array_search("download", $fields);


		//		if(isset($_POST['remove'][$id]))
		//		{
		//		$ptypes = JRequest::getVar('pparams');
		//		JFile::delete($path.DS.'product_type'.DS.$row->user_id.DS.$ptypes[$id]['file-'.$id]);
		//		}
		$ptypes = JRequest::getVar('pparams');
		$name =  $fields[$id]['files'][0];
		if($name)// = $_FILES['files']['name'][$id])
		{
		$tmp_name = $_FILES['files']['tmp_name'][$id];
		$size	= $_FILES['files']['size'][$id];
		//$name =  $fields[$id]['files'][0];
		$file_value 	= $db->getEscaped($name);
		$ext 	= strtolower(substr($name, strrpos($name, '.') + 1));

		$sql = "SELECT params FROM #__js_res_fields WHERE id='$id'";
		$db->setQuery($sql);
		$fparams = $db->loadResult();
		$dparams = new JParameter($fparams);
		$exts 	= explode(", ", $dparams->get('allowed_formats'));
		$folder = $path;

		if(!JFolder::exists($folder))
		{
		if(!JFolder::create($folder))
		{
		$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
		$message .= "<br>Folder: ".$folder;
		JError::raiseError(403, $message);
		$error = 1; return;
		}
		}
		//$folder .= DS.$type;
		$folder .= DS.'product_type';
		if(!JFolder::exists($folder))
		{
		if(!JFolder::create($folder))
		{
		$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
		$message .= "<br>Folder: ".$folder;
		JError::raiseError(403, $message);
		$error = 1; return;
		}
		}
		$folder .= DS.$row->user_id;
		if(!JFolder::exists($folder))
		{
		if(!JFolder::create($folder))
		{
		$message = JText::_('Cannot upload file(s), Please, check upload directory is correct and accessible');
		$message .= "<br>Folder: ".$folder;
		JError::raiseError(403, $message);
		$error = 1; return;
		}
		}
		if(!in_array($ext, $exts))
		{
		$msg = JText::_("File is not apropriate format");
		$msg .= "<br>File: ".$name;
		$msg .= "<br>Allowed Formats: ".implode(", ", $exts);
		JError::raiseWarning(403, $msg);
		$error = 1; return;
		}

		if($params->get('attach')){ $name = $name; $file_value = $name;}

		$dest = $folder.DS.$name;

		if(JFile::exists($dest) && !$params->get('overwrite'))
		{
		$msg = JText::_("This File already Exists");
		$msg .= "<br>File: ".$name;
		JError::raiseWarning(403, $msg);
		$error = 1; return;
		}
		if(!JFile::upload($name, $dest))
		{
		$msg = JText::_("Could not upload the file");
		$msg .= "<br>File: ".$name;
		JError::raiseError(403, $msg);
		$error = 1; return;
		}
		}
		}*/

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		
		if($type != 'download') return;
		if(!$field) return;

		$params = new JParameter($field->params);
		$user = $record->user_id;
		$fval = explode("=", $field->value);
		if(!isset($fval[1]) || $fval[1] == '' || $fval[1] == -1) return;

		$db = & JFactory::getDBO();
		$uri = JFactory::getURI();
		$me = JFactory::getUser();
		$out = '';
		$sql = "SELECT id FROM #__js_res_record_values WHERE field_id = '{$field->field_id}' AND record_id = '{$field->record_id}'";
		$db->setQuery($sql);
		$file_id = $db->loadResult();

		$hits = $this->jsGetHits($file_id);

		$load = false;
		$buyer = false;
		if($me->id)
		{
			$sql = "SELECT COUNT(*) FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = '{$me->id}'
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($res = $db->loadResult())
			$buyer = $me->id;
		}
		else
		{
			$sql = "SELECT ord. email FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = 0
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($order_emails = $db->loadResultArray())
			{
				$session = JFactory::getSession();
				if($customer = $session->get('customer'))
				{
					if(in_array($customer['cemail'], $order_emails))
					{
						$buyer = $customer['cemail'];
					}
				}

			}
		}

		if($buyer)
		{
			if($field->field_value_id )
			{
				if($field->ip == $buyer)
				$load = true;
			}
			else
			$load = true;
		}

		if($load)
		{
			$sql = "SELECT ex.value, ex.ref_id, ex.record_id, ex.user_id, ex.field_id
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__jc_orders_statuses os ON os.id = pr.status_id
			JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
			WHERE ex.field_id = '{$field->field_id}'
			AND ex.record_id = '".(JRequest::getInt('download') && JRequest::getInt('record_id') ? JRequest::getInt('record_id') : $field->record_id)."'
			AND ord.user_id = '".$me->id."' AND os.isfinal = '1'";
			$db->setQuery($sql);
			if($res = $db->loadObject())
			{
				$path = JPATH_ROOT.DS.$params->get('directory');
				$val = explode("-", $fval[0]);

				if(JRequest::getInt('download') && JRequest::getInt('field') && JRequest::getInt('field') == $val[1])// && (!$params->get('unique') || ($params->get('unique') && $hits < 1) ))
				{
					$user = & JFactory::getUser();
					$id = JRequest::getInt('file');
					$db = & JFactory::getDBO();

					$browser =  $_SERVER['HTTP_USER_AGENT'];
					//echo $browser;

					if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OPERA';
					} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'IE';
					} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OMNIWEB';
					} else if(ereg('(Konqueror/)(.*)', $browser)) {
						$browser =  'KONQUEROR';
					} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'MOZILLA';
					} else {
						$browser =  'OTHER';
					}

					if(!$res)
					{
						JError::raiseError(500, JText::_('Item Not found'));
					}
					$fvalue = explode("=", $res->value);

					if(isset($fvalue[1]) && $fvalue[1] != '' )
					{
						if($params->get('type', 1) == 1)
						{
							$file = $path.DS.'product_type'.DS.$res->user_id;
							$file .= DS.$fvalue[1];
						}
						else
						{
							$file = JPath::clean(JPATH_ROOT.DS.$fvalue[1]);
						}
						//$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$fvalue[1];
						//echo $file;
						//exit;
						if(file_exists($file))
						{
							$this->hit($file_id);
							header('Content-Type: '.(($browser=='IE' || $browser=='OPERA') ? 'application/octetstream':'application/octet-stream'));
							header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
							header('Content-Transfer-Encoding: binary');
							header('Content-Length: '.filesize($file));
							header("Content-Encoding: none");
							if($browser=='IE') {
								header('Content-Disposition: attachment; filename="'.basename($fvalue[1]).'"');
								header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
								header('Pragma: public');
							} else {
								header('Content-Disposition: attachment; filename="'.basename($fvalue[1]).'"');
								header('Cache-Control: no-cache, must-revalidate');
								header('Pragma: no-cache');
							}
							$this->readfile_chunked($file);
							exit;

						}
					}
				}

				$value = explode("=", $field->value);
				$val = explode("-", $value[0]);

				switch ($params->get('type'))
				{
					case 1:
						$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$value[1];
						break;
					case 3:
					case 2:
						$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						break;
				}
				//$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$value[1];


				if(file_exists($file))
				{

					$uri->setVar('download', '1');
					$uri->setVar('record_id', $res->record_id);
					$uri->setVar('field', $val[1]);
					$download = $uri->toString();
					$uri->delVar('download');
					$uri->delVar('record_id');
					$uri->delVar('field');

					if($params->get('show_name'))
					{
						$label = basename($value[1]);
					}
					else {
						$label = JText::_("Download file");
					}

					$link = JHTML::link($download, $label); //, 'target="_blank"'

					$out .= $link;

					$addition = array();

					if($params->get('show_size'))
					{
						$addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($file));
					}
					if($params->get('show_hits', 1))
					{
						$addition[] = JText::_('Hits').': '.$this->jsGetHits($file_id);
					}
					if($params->get('show_ctime'))
					{
						$addition[] = JText::_('Create Time').': '.strftime(JText::_('%d %b %Y'), filectime($file));
					}
					if(count($addition) > 0) $out .= ' <span class="small js_small">('.implode(" | ", $addition).')</span> ';
				}
			}
			else
			$out = JText::_("To get download url you need to purchase this product");
		}
		else
		{
			$out = JText::_("To get download url you need to purchase this product");
			if($field->field_value_id && !$load && $field->ip != '' )
			$out = JText::_('There is no file on storage');
		}

	}

	function onAfterSuccessOrder($type, $order_id, $product_id, $field_id, $value, $user_id, $amount)
	{
		if($type != 'download') return;
		if($value == '') return;
		$db = & JFactory::getDBO();
		if(!$user_id)
		{
			$sql = "SELECT email FROM #__jc_orders WHERE id = '$order_id'";
			$db->setQuery($sql);
			$user_id = $db->loadResult();
		}
		$sql = "UPDATE #__js_res_field_extra SET ip = '$user_id' WHERE record_id = '$product_id' AND field_id = '$field_id' AND ref_id = 'download'
		AND ip = ''";
		$db->setQuery($sql);
		$db->query();
	}

	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'download') return;
		if($value == '') return;
		$out = '';
		$params = new JParameter($params);

		$db = & JFactory::getDBO();
		$out = '';

		$db = & Jfactory::getDBO();
		$path = JPATH_ROOT.DS.$params->get('directory');

		$value = explode("=", $value);
		$val = explode("-", $value[0]);
		if(isset($val[1]) && $val[1] != '' && $value[1] != '-1')
		{
			$sql = "SELECT id FROM #__js_res_record_values WHERE field_id = '$val[1]' AND record_id = '$product_id'";
			$db->setQuery($sql);
			$file_id = $db->loadResult();
			$hits = $this->jsGetHits($file_id);

			$me = JFactory::getUser();

			$load = false;
			$buyer = false;
			if($me->id)
			{
				if($final_status)
				$buyer = $me->id;
			}
			else
			{
				$sql = "SELECT ord. email FROM #__jc_orders ord
				JOIN #__jc_orders_products pr ON ord.id = pr.order_id
				WHERE product_id = '{$product_id}' AND ord.user_id = 0
				AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
				$db->setQuery($sql);
				if($order_emails = $db->loadResultArray())
				{
					$session = JFactory::getSession();
					if($customer = $session->get('customer'))
					{
						if(in_array($customer['cemail'], $order_emails))
						{
							$buyer = $customer['cemail'];
						}
					}
				}
			}

			if($buyer)
			{
				if($params->get('fvid'))
				{
					if($params->get('ip') == $buyer)
					$load = true;
				}
				else
				$load = true;
			}


			if($load)
			{
				$path = JPATH_ROOT.DS.$params->get('directory');
				$sql = "SELECT user_id FROM #__js_res_record WHERE id = '$product_id'";
				$db->setQuery($sql);
				$author = $db->loadResult();

				if(JRequest::getInt('download') && JRequest::getInt('field') && JRequest::getInt('field') == $val[1])
				{
					$id = JRequest::getInt('field');

					/*
					 $rid = JRequest::getInt('record_id');
					 $sql = "SELECT field_value FROM #__js_res_record_values
					 WHERE record_id = '$rid' AND field_id = '$id'";
					 $db->setQuery($sql);
					 $value[1] = $db->loadResult();

					 print  "<pre>";
					 print_r($params);
					 print  "</pre>";*/
					$user = & JFactory::getUser();

					$browser =  $_SERVER['HTTP_USER_AGENT'];
					//echo $browser;

					if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OPERA';
					} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'IE';
					} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OMNIWEB';
					} else if(ereg('(Konqueror/)(.*)', $browser)) {
						$browser =  'KONQUEROR';
					} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'MOZILLA';
					} else {
						$browser =  'OTHER';				}


						if(isset($value[1]) && $value[1] != '' )
						{
							if($params->get('type', 1) == 1)
							{
								$file = $path.DS.'product_type'.DS.$author;
								$file .= DS.$value[1];
							}
							else
							{
								$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
							}

							if(file_exists($file))
							{
								$this->hit($file_id);
								header('Content-Type: '.(($browser=='IE' || $browser=='OPERA') ? 'application/octetstream':'application/octet-stream'));
								header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
								header('Content-Transfer-Encoding: binary');
								header('Content-Length: '.filesize($file));
								header("Content-Encoding: none");
								if($browser=='IE') {
									header('Content-Disposition: attachment; filename="'.basename($value[1]).'"');
									header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
									header('Pragma: public');
								} else {
									header('Content-Disposition: attachment; filename="'.basename($value[1]).'"');
									header('Cache-Control: no-cache, must-revalidate');
									header('Pragma: no-cache');
								}
								$this->readfile_chunked($file);
								exit;
							}
						}
				}

				switch ($params->get('type'))
				{
					case 1:
						$file   = $path.DS.'product_type'.DS.$author.DS.$value[1];
						break;
					case 3:
					case 2:
						$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						break;
				}

				if(file_exists($file))
				{
					$uri = JFactory::getURI();
					$uri->setVar('download', '1');
					$uri->setVar('record_id', $product_id);
					$uri->setVar('field', $val[1]);
					$download = $uri->toString();
					$uri->delVar('download');
					$uri->delVar('record_id');
					$uri->delVar('field');

					if($params->get('show_name'))
					{
						$label = basename($value[1]);
					}
					else {
						$label = JText::_("Download file");
					}

					$link = JHTML::link($download, $label); //, 'target="_blank"'

					$out = $link;

					$addition = array();

					if($params->get('show_size'))
					{
						$addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($file));
					}
					if($params->get('show_hits', 1))
					{
						$addition[] = JText::_('Hits').': '.$this->jsGetHits($file_id);
					}
					if($params->get('show_ctime'))
					{
						$addition[] = JText::_('Create Time').': '.strftime(JText::_('%d %b %Y'), filectime($file));
					}
					if(count($addition) > 0) $out .= ' <span class="small js_small">('.implode(" | ", $addition).')</span> ';
				}
			}
			/*
			 else
			 $out = JText::_("Order must be shipped to get access to download file");*/

		}

		return $out;
	}

	function onTypeFormRender()
	{

	}

	function onBeforeCartStore()
	{

	}
	function jsFormatSize($size)
	{

		$kb = 1024;
		$mgb = $kb * 1024;
		$gb  = $mgb * 1024;
		$trb = $gb * 1024;

		if($size > $trb)
		{
			return number_format($size / $trb, 2, ',', ' ')." Tb";
		}
		elseif($size > $gb)
		{
			return number_format($size / $gb, 1, ',', ' ')." Gb";
		}
		elseif($size > $mgb)
		{
			return number_format($size / $mgb, 0, ',', ' ')." Mb";
		}
		elseif($size > $kb)
		{
			return number_format($size / $kb, 0, ',', ' ')." Kb";
		}
		else
		{
			return $size." B";
		}
	}
	function jsGetHits($id)
	{
		$db = &JFactory::getDBO();

		$sql = "SELECT COUNT(*) FROM #__js_res_download_hits WHERE item_id = '{$id}'";
		$db->setQuery($sql);
		return intval($db->loadResult());
	}
	function hit($id)
	{
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$uid = $user->get('id');

		$sql = "INSERT INTO #__js_res_download_hits VALUES(NULL, '{$uid}', '{$id}', NOW(), '".$_SERVER['REMOTE_ADDR']."')";
		$db->setQuery($sql);
		$db->query();
	}

	function readfile_chunked($filename,$retbytes=true) {
		error_reporting(0);
		//ignore_user_abort(true);
		set_time_limit(0);
		$chunksize = 1*(1024*1024); // how many bytes per chunk
		$buffer = '';
		$cnt =0;
		// $handle = fopen($filename, 'rb');
		$handle = fopen($filename, 'rb');
		if ($handle === false) {
			echo "Cannot open file"; exit;
			return false;
		}
		while (!feof($handle)) {
			$buffer = @fread($handle, $chunksize);
			echo $buffer;
			if ($retbytes) {
				$cnt += strlen($buffer);
			}
		}
		$status = fclose($handle);
		if ($retbytes && $status) {
			return $cnt; // return num. bytes delivered like readfile() does.
		}
		return $status;
	}
}
?>